#pragma once

// --- Includes ---
#include <SDL3/SDL.h>
#include <stdint.h>  // Para uint32_t, uint8_t
#include <stdio.h>   // Para NULL, fseek, printf, fclose, fopen, fread, ftell, FILE, SEEK_END, SEEK_SET
#include <stdlib.h>  // Para free, malloc
#include <string.h>  // Para strcpy, strlen

#define STB_VORBIS_HEADER_ONLY
#include "external/stb_vorbis.h"  // Para stb_vorbis_decode_memory

// --- Public Enums ---
enum JA_Channel_state { JA_CHANNEL_INVALID,
    JA_CHANNEL_FREE,
    JA_CHANNEL_PLAYING,
    JA_CHANNEL_PAUSED,
    JA_SOUND_DISABLED };
enum JA_Music_state { JA_MUSIC_INVALID,
    JA_MUSIC_PLAYING,
    JA_MUSIC_PAUSED,
    JA_MUSIC_STOPPED,
    JA_MUSIC_DISABLED };

// --- Struct Definitions ---
#define JA_MAX_SIMULTANEOUS_CHANNELS 20
#define JA_MAX_GROUPS 2

struct JA_Sound_t {
        SDL_AudioSpec spec{SDL_AUDIO_S16, 2, 48000};
        Uint32 length{0};
        Uint8* buffer{NULL};
};

struct JA_Channel_t {
        JA_Sound_t* sound{nullptr};
        int pos{0};
        int times{0};
        int group{0};
        SDL_AudioStream* stream{nullptr};
        JA_Channel_state state{JA_CHANNEL_FREE};
};

struct JA_Music_t {
        SDL_AudioSpec spec{SDL_AUDIO_S16, 2, 48000};
        Uint32 length{0};
        Uint8* buffer{nullptr};
        char* filename{nullptr};

        int pos{0};
        int times{0};
        SDL_AudioStream* stream{nullptr};
        JA_Music_state state{JA_MUSIC_INVALID};
};

// --- Internal Global State ---
// Marcado 'inline' (C++17) para asegurar una única instancia.

inline JA_Music_t* current_music{nullptr};
inline JA_Channel_t channels[JA_MAX_SIMULTANEOUS_CHANNELS];

inline SDL_AudioSpec JA_audioSpec{SDL_AUDIO_S16, 2, 48000};
inline float JA_musicVolume{1.0F};
inline float JA_soundVolume[JA_MAX_GROUPS];
inline bool JA_musicEnabled{true};
inline bool JA_soundEnabled{true};
inline SDL_AudioDeviceID sdlAudioDevice{0};

inline bool fading{false};
inline int fade_start_time{0};
inline int fade_duration{0};
inline float fade_initial_volume{0.0F};  // Corregido de 'int' a 'float'

// --- Forward Declarations ---
inline void JA_StopMusic();
inline void JA_StopChannel(const int channel);
inline int JA_PlaySoundOnChannel(JA_Sound_t* sound, const int channel, const int loop = 0, const int group = 0);

// --- Core Functions ---

inline void JA_Update() {
    if (JA_musicEnabled && current_music && current_music->state == JA_MUSIC_PLAYING) {
        if (fading) {
            int time = SDL_GetTicks();
            if (time > (fade_start_time + fade_duration)) {
                fading = false;
                JA_StopMusic();
                return;
            } else {
                const int time_passed = time - fade_start_time;
                const float percent = (float)time_passed / (float)fade_duration;
                SDL_SetAudioStreamGain(current_music->stream, JA_musicVolume * (1.0 - percent));
            }
        }

        if (current_music->times != 0) {
            if ((Uint32)SDL_GetAudioStreamAvailable(current_music->stream) < (current_music->length / 2)) {
                SDL_PutAudioStreamData(current_music->stream, current_music->buffer, current_music->length);
            }
            if (current_music->times > 0) current_music->times--;
        } else {
            if (SDL_GetAudioStreamAvailable(current_music->stream) == 0) JA_StopMusic();
        }
    }

    if (JA_soundEnabled) {
        for (int i = 0; i < JA_MAX_SIMULTANEOUS_CHANNELS; ++i)
            if (channels[i].state == JA_CHANNEL_PLAYING) {
                if (channels[i].times != 0) {
                    if ((Uint32)SDL_GetAudioStreamAvailable(channels[i].stream) < (channels[i].sound->length / 2)) {
                        SDL_PutAudioStreamData(channels[i].stream, channels[i].sound->buffer, channels[i].sound->length);
                        if (channels[i].times > 0) channels[i].times--;
                    }
                } else {
                    if (SDL_GetAudioStreamAvailable(channels[i].stream) == 0) JA_StopChannel(i);
                }
            }
    }
}

inline void JA_Init(const int freq, const SDL_AudioFormat format, const int num_channels) {
#ifdef _DEBUG
    SDL_SetLogPriority(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_DEBUG);
#endif

    JA_audioSpec = {format, num_channels, freq};
    if (sdlAudioDevice) SDL_CloseAudioDevice(sdlAudioDevice);  // Corregido: !sdlAudioDevice -> sdlAudioDevice
    sdlAudioDevice = SDL_OpenAudioDevice(SDL_AUDIO_DEVICE_DEFAULT_PLAYBACK, &JA_audioSpec);
    if (sdlAudioDevice == 0) SDL_Log("Failed to initialize SDL audio!");
    for (int i = 0; i < JA_MAX_SIMULTANEOUS_CHANNELS; ++i) channels[i].state = JA_CHANNEL_FREE;
    for (int i = 0; i < JA_MAX_GROUPS; ++i) JA_soundVolume[i] = 0.5F;
}

inline void JA_Quit() {
    if (sdlAudioDevice) SDL_CloseAudioDevice(sdlAudioDevice);  // Corregido: !sdlAudioDevice -> sdlAudioDevice
    sdlAudioDevice = 0;
}

// --- Music Functions ---

inline JA_Music_t* JA_LoadMusic(const Uint8* buffer, Uint32 length) {
    JA_Music_t* music = new JA_Music_t();

    int chan, samplerate;
    short* output;
    music->length = stb_vorbis_decode_memory(buffer, length, &chan, &samplerate, &output) * chan * 2;

    music->spec.channels = chan;
    music->spec.freq = samplerate;
    music->spec.format = SDL_AUDIO_S16;
    music->buffer = static_cast<Uint8*>(SDL_malloc(music->length));
    SDL_memcpy(music->buffer, output, music->length);
    free(output);
    music->pos = 0;
    music->state = JA_MUSIC_STOPPED;

    return music;
}

inline JA_Music_t* JA_LoadMusic(const char* filename) {
    // [RZC 28/08/22] Carreguem primer el arxiu en memòria i després el descomprimim. Es algo més rapid.
    FILE* f = fopen(filename, "rb");
    if (!f) return NULL;  // Añadida comprobación de apertura
    fseek(f, 0, SEEK_END);
    long fsize = ftell(f);
    fseek(f, 0, SEEK_SET);
    auto* buffer = static_cast<Uint8*>(malloc(fsize + 1));
    if (!buffer) {  // Añadida comprobación de malloc
        fclose(f);
        return NULL;
    }
    if (fread(buffer, fsize, 1, f) != 1) {
        fclose(f);
        free(buffer);
        return NULL;
    }
    fclose(f);

    JA_Music_t* music = JA_LoadMusic(buffer, fsize);
    if (music) {  // Comprobar que JA_LoadMusic tuvo éxito
        music->filename = static_cast<char*>(malloc(strlen(filename) + 1));
        if (music->filename) {
            strcpy(music->filename, filename);
        }
    }

    free(buffer);

    return music;
}

inline void JA_PlayMusic(JA_Music_t* music, const int loop = -1) {
    if (!JA_musicEnabled || !music) return;  // Añadida comprobación de music

    JA_StopMusic();

    current_music = music;
    current_music->pos = 0;
    current_music->state = JA_MUSIC_PLAYING;
    current_music->times = loop;

    current_music->stream = SDL_CreateAudioStream(&current_music->spec, &JA_audioSpec);
    if (!current_music->stream) {  // Comprobar creación de stream
        SDL_Log("Failed to create audio stream!");
        current_music->state = JA_MUSIC_STOPPED;
        return;
    }
    if (!SDL_PutAudioStreamData(current_music->stream, current_music->buffer, current_music->length)) printf("[ERROR] SDL_PutAudioStreamData failed!\n");
    SDL_SetAudioStreamGain(current_music->stream, JA_musicVolume);
    if (!SDL_BindAudioStream(sdlAudioDevice, current_music->stream)) printf("[ERROR] SDL_BindAudioStream failed!\n");
}

inline char* JA_GetMusicFilename(const JA_Music_t* music = nullptr) {
    if (!music) music = current_music;
    if (!music) return nullptr;  // Añadida comprobación
    return music->filename;
}

inline void JA_PauseMusic() {
    if (!JA_musicEnabled) return;
    if (!current_music || current_music->state != JA_MUSIC_PLAYING) return;  // Comprobación mejorada

    current_music->state = JA_MUSIC_PAUSED;
    SDL_UnbindAudioStream(current_music->stream);
}

inline void JA_ResumeMusic() {
    if (!JA_musicEnabled) return;
    if (!current_music || current_music->state != JA_MUSIC_PAUSED) return;  // Comprobación mejorada

    current_music->state = JA_MUSIC_PLAYING;
    SDL_BindAudioStream(sdlAudioDevice, current_music->stream);
}

inline void JA_StopMusic() {
    if (!current_music || current_music->state == JA_MUSIC_INVALID || current_music->state == JA_MUSIC_STOPPED) return;

    current_music->pos = 0;
    current_music->state = JA_MUSIC_STOPPED;
    if (current_music->stream) {
        SDL_DestroyAudioStream(current_music->stream);
        current_music->stream = nullptr;
    }
    // No liberamos filename aquí, se debería liberar en JA_DeleteMusic
}

inline void JA_FadeOutMusic(const int milliseconds) {
    if (!JA_musicEnabled) return;
    if (current_music == NULL || current_music->state == JA_MUSIC_INVALID) return;

    fading = true;
    fade_start_time = SDL_GetTicks();
    fade_duration = milliseconds;
    fade_initial_volume = JA_musicVolume;
}

inline JA_Music_state JA_GetMusicState() {
    if (!JA_musicEnabled) return JA_MUSIC_DISABLED;
    if (!current_music) return JA_MUSIC_INVALID;

    return current_music->state;
}

inline void JA_DeleteMusic(JA_Music_t* music) {
    if (!music) return;
    if (current_music == music) {
        JA_StopMusic();
        current_music = nullptr;
    }
    SDL_free(music->buffer);
    if (music->stream) SDL_DestroyAudioStream(music->stream);
    free(music->filename);  // filename se libera aquí
    delete music;
}

inline float JA_SetMusicVolume(float volume) {
    JA_musicVolume = SDL_clamp(volume, 0.0F, 1.0F);
    if (current_music && current_music->stream) {
        SDL_SetAudioStreamGain(current_music->stream, JA_musicVolume);
    }
    return JA_musicVolume;
}

inline void JA_SetMusicPosition(float value) {
    if (!current_music) return;
    current_music->pos = value * current_music->spec.freq;
    // Nota: Esta implementación de 'pos' no parece usarse en JA_Update para
    // el streaming. El streaming siempre parece empezar desde el principio.
}

inline float JA_GetMusicPosition() {
    if (!current_music) return 0;
    return float(current_music->pos) / float(current_music->spec.freq);
    // Nota: Ver `JA_SetMusicPosition`
}

inline void JA_EnableMusic(const bool value) {
    if (!value && current_music && (current_music->state == JA_MUSIC_PLAYING)) JA_StopMusic();

    JA_musicEnabled = value;
}

// --- Sound Functions ---

inline JA_Sound_t* JA_NewSound(Uint8* buffer, Uint32 length) {
    JA_Sound_t* sound = new JA_Sound_t();
    sound->buffer = buffer;
    sound->length = length;
    // Nota: spec se queda con los valores por defecto.
    return sound;
}

inline JA_Sound_t* JA_LoadSound(uint8_t* buffer, uint32_t size) {
    JA_Sound_t* sound = new JA_Sound_t();
    if (!SDL_LoadWAV_IO(SDL_IOFromMem(buffer, size), 1, &sound->spec, &sound->buffer, &sound->length)) {
        SDL_Log("Failed to load WAV from memory: %s", SDL_GetError());
        delete sound;
        return nullptr;
    }
    return sound;
}

inline JA_Sound_t* JA_LoadSound(const char* filename) {
    JA_Sound_t* sound = new JA_Sound_t();
    if (!SDL_LoadWAV(filename, &sound->spec, &sound->buffer, &sound->length)) {
        SDL_Log("Failed to load WAV file: %s", SDL_GetError());
        delete sound;
        return nullptr;
    }
    return sound;
}

inline int JA_PlaySound(JA_Sound_t* sound, const int loop = 0, const int group = 0) {
    if (!JA_soundEnabled || !sound) return -1;

    int channel = 0;
    while (channel < JA_MAX_SIMULTANEOUS_CHANNELS && channels[channel].state != JA_CHANNEL_FREE) { channel++; }
    if (channel == JA_MAX_SIMULTANEOUS_CHANNELS) {
        // No hay canal libre, reemplazamos el primero
        channel = 0;
    }

    return JA_PlaySoundOnChannel(sound, channel, loop, group);
}

inline int JA_PlaySoundOnChannel(JA_Sound_t* sound, const int channel, const int loop, const int group) {
    if (!JA_soundEnabled || !sound) return -1;
    if (channel < 0 || channel >= JA_MAX_SIMULTANEOUS_CHANNELS) return -1;

    JA_StopChannel(channel);  // Detiene y limpia el canal si estaba en uso

    channels[channel].sound = sound;
    channels[channel].times = loop;
    channels[channel].pos = 0;
    channels[channel].group = group;  // Asignar grupo
    channels[channel].state = JA_CHANNEL_PLAYING;
    channels[channel].stream = SDL_CreateAudioStream(&channels[channel].sound->spec, &JA_audioSpec);

    if (!channels[channel].stream) {
        SDL_Log("Failed to create audio stream for sound!");
        channels[channel].state = JA_CHANNEL_FREE;
        return -1;
    }

    SDL_PutAudioStreamData(channels[channel].stream, channels[channel].sound->buffer, channels[channel].sound->length);
    SDL_SetAudioStreamGain(channels[channel].stream, JA_soundVolume[group]);
    SDL_BindAudioStream(sdlAudioDevice, channels[channel].stream);

    return channel;
}

inline void JA_DeleteSound(JA_Sound_t* sound) {
    if (!sound) return;
    for (int i = 0; i < JA_MAX_SIMULTANEOUS_CHANNELS; i++) {
        if (channels[i].sound == sound) JA_StopChannel(i);
    }
    SDL_free(sound->buffer);
    delete sound;
}

inline void JA_PauseChannel(const int channel) {
    if (!JA_soundEnabled) return;

    if (channel == -1) {
        for (int i = 0; i < JA_MAX_SIMULTANEOUS_CHANNELS; i++)
            if (channels[i].state == JA_CHANNEL_PLAYING) {
                channels[i].state = JA_CHANNEL_PAUSED;
                SDL_UnbindAudioStream(channels[i].stream);
            }
    } else if (channel >= 0 && channel < JA_MAX_SIMULTANEOUS_CHANNELS) {
        if (channels[channel].state == JA_CHANNEL_PLAYING) {
            channels[channel].state = JA_CHANNEL_PAUSED;
            SDL_UnbindAudioStream(channels[channel].stream);
        }
    }
}

inline void JA_ResumeChannel(const int channel) {
    if (!JA_soundEnabled) return;

    if (channel == -1) {
        for (int i = 0; i < JA_MAX_SIMULTANEOUS_CHANNELS; i++)
            if (channels[i].state == JA_CHANNEL_PAUSED) {
                channels[i].state = JA_CHANNEL_PLAYING;
                SDL_BindAudioStream(sdlAudioDevice, channels[i].stream);
            }
    } else if (channel >= 0 && channel < JA_MAX_SIMULTANEOUS_CHANNELS) {
        if (channels[channel].state == JA_CHANNEL_PAUSED) {
            channels[channel].state = JA_CHANNEL_PLAYING;
            SDL_BindAudioStream(sdlAudioDevice, channels[channel].stream);
        }
    }
}

inline void JA_StopChannel(const int channel) {
    if (channel == -1) {
        for (int i = 0; i < JA_MAX_SIMULTANEOUS_CHANNELS; i++) {
            if (channels[i].state != JA_CHANNEL_FREE) {
                if (channels[i].stream) SDL_DestroyAudioStream(channels[i].stream);
                channels[i].stream = nullptr;
                channels[i].state = JA_CHANNEL_FREE;
                channels[i].pos = 0;
                channels[i].sound = NULL;
            }
        }
    } else if (channel >= 0 && channel < JA_MAX_SIMULTANEOUS_CHANNELS) {
        if (channels[channel].state != JA_CHANNEL_FREE) {
            if (channels[channel].stream) SDL_DestroyAudioStream(channels[channel].stream);
            channels[channel].stream = nullptr;
            channels[channel].state = JA_CHANNEL_FREE;
            channels[channel].pos = 0;
            channels[channel].sound = NULL;
        }
    }
}

inline JA_Channel_state JA_GetChannelState(const int channel) {
    if (!JA_soundEnabled) return JA_SOUND_DISABLED;
    if (channel < 0 || channel >= JA_MAX_SIMULTANEOUS_CHANNELS) return JA_CHANNEL_INVALID;

    return channels[channel].state;
}

inline float JA_SetSoundVolume(float volume, const int group = -1)  // -1 para todos los grupos
{
    const float v = SDL_clamp(volume, 0.0F, 1.0F);

    if (group == -1) {
        for (int i = 0; i < JA_MAX_GROUPS; ++i) {
            JA_soundVolume[i] = v;
        }
    } else if (group >= 0 && group < JA_MAX_GROUPS) {
        JA_soundVolume[group] = v;
    } else {
        return v;  // Grupo inválido
    }

    // Aplicar volumen a canales activos
    for (int i = 0; i < JA_MAX_SIMULTANEOUS_CHANNELS; i++) {
        if ((channels[i].state == JA_CHANNEL_PLAYING) || (channels[i].state == JA_CHANNEL_PAUSED)) {
            if (group == -1 || channels[i].group == group) {
                if (channels[i].stream) {
                    SDL_SetAudioStreamGain(channels[i].stream, JA_soundVolume[channels[i].group]);
                }
            }
        }
    }
    return v;
}

inline void JA_EnableSound(const bool value) {
    if (!value) {
        JA_StopChannel(-1);  // Detener todos los canales
    }
    JA_soundEnabled = value;
}

inline float JA_SetVolume(float volume) {
    float v = JA_SetMusicVolume(volume);
    JA_SetSoundVolume(v, -1);  // Aplicar a todos los grupos de sonido
    return v;
}